//////////////////////////////////////////////////////////////////////////////////////////
// Direct3D Breakout Demo - Version 0.7 - June 21st, 2004 by Jeff Cummings (Programmer)
// BasicWindowsApp_058.CPP
//////////////////////////////////////////////////////////////////////////////////////////

// Version 0.2
// Frames per Second ADDED 2:20am 5/25/04
// Bounced a picture around the screen. 1pm 5/25/04
// One Ball Bouncing around the Screen 3:23am 5/26/04
// Multiple Balls Bouncing around the Screen 3:27am 5/26/04

// Version 0.3
// Background image of MARS ADDED 1:10pm 5/26/04
// BALLS.BMP saved with Alpha Channels (new concept learned) 1:16pm 5/26/04
// Created .BMP files for each of FIVE BLOCKS, and ONE PADDLE (JUPITER'S STORM)
// ADDED Mouse Controlled Paddle with Jupiter's Storm Texture 5:31am 5/27/04 Using Win GDI
// ADDED Textured Blocks, I've only got five, what a variety... 1:46pm 5/27/04

// Version 0.4
// Successfully transferred Init_Blocks function, the poly_count++ was forgot...
// took me 1 1/2 hours to figure that little fact out...yep, I'm a programmer! :-)
// 1:04am 5/31/04 ADDED 360 Degree Directional Vector for Balls
// AND Balls and Blocks variable consolidation of structure variables, all in one :-)
// Optimized_Collisions function ADDED successfully is the word 12:39am It works! :-)
// Eliminated some Global Variables 12:08am 6/2/04 (just after midnight)
// Fixed Balls Initial Trajector 12:31am 6/2/04
// Also Fixed Perfect Bounce by reducing Balls' Scale Values 12:31am 6/2/04
// Perfected Block #s and Scale Size by calculating in Construct_Blocks 1:33am 6/2/04

// Version 0.5
// Time-Based Velocity ADDED 2:12am 6/2/04
// Time-Based Velocity removed 2:08pm 6/2/04
// Centered Play Area on Screen, ADDED Title, Credits, Special Thanks 2:10am 6/6/04
// Switched from Win GDI to Direct Input, after help from DXSDK Tutorials!!! YES 1:13am 6/9/04
// Switched to Modified Textures from GRSITES.COM!!! 2:19am 6/9/04
// Paddle Collision Bouncing ADDED 2:55am 6/9/04
// Switch to ONE BALL TEXTURE! ADDED 3:03am 6/9/04

// Version 0.6
// Text On-Screen only if 3D Card active ADDED 1:08am 6/10/04
// LOCKED Frame Rate to 63 frames/sec (Andre) ADDED 1:41am 6/10/04
// Adding Textures: Change NUM_TEX and WinMain D3DXCreateTextureFromFile()s ADDED 7 @ 2:38am 6/10
// Simple Block Initialization Pattern for Level One: DEMO ADDED 12:41pm 6/11/04
// 16 Global Variables Eliminated WinMain() and Render() merged 2:30am 6/12/04
// MP3 for Background Music w/Direct Show Interface ADDED 12:25pm 6/12/04 SUPER SMILE :-)
// Title and Thanks on background bitmap ADDED 12:33pm 6/13/04
// Block Elimination SCORING! ADDED 12:40pm 6/13/04
// Moved to Game_Init, Game_Shutdown, Game_Main style w/ Globals again...:-) 1:09am 6/14/04
// Uniform rotation of blocks ADDED 1:54am 6/14/04
// Computer Controlled Paddle ADDED 5:03pm 6/15/04
// Rotation fixed for calculation of center 5:15pm 6:15/04
// Blocks spin into place from edges of screen ADDED 10:44pm 6/15/04
// Simple Pattern for Level One Generated in Code ADDED 12:32am 6/16/04
// Ordered Visual C++.NET Standard Edition !!! 6/15/04
// Installed Visual c++.NET 6/19/04 AWESOME!!! :-)
// Computer Controls Track all balls, and aim for nearest ball. ADDED 1:46am 6/20/04
// Ball Elimination ADDED 1:28am 6/21/04
// Resource Files: D3DX9.LIB, DXGUID.LIB, DINPUT8.LIB, WINMM.LIB, D3D9.LIB, STRMIIDS.LIB
// Direct Input 8 Create NEEDS THIS...MUST HAVE!!! unless you link in DXGUID.LIB...SIGH
//#define INITGUID

// Version 0.7
// Ball Elimination FIXED 3:01am 6/21/04

// Title Screen like oldtime Pac Man w/Special Effects (even 3D)

// Commenting Variables Uses and Purposes, Function Purposes and Relationships
// How can I use classes to encapsulate my code?
// Write to Andre LaMothe ceo@xgames3d.com (send Release Version 1.0)
// Write to Red Seven Software (send them Release Version 1.0)
// Unlimited Levels. HIGH SCORE Display,
// Trails and/or Lightning for Ball/Paddle Movement (Particle Systems)
// Special Blocks / Surprises, etc. with Special Effects! (Even More Textures / Styles = 20 to 30)
// Optimization One Upgrade: Determine Corner Block #s and only update MINMAX rect
// if one of those corners is hit.
// Optimization Two Upgrade: Have a minmax2 rect for each row / column...ADVANCED optimization.

// Adobe Photoshop!! Milkshape 3D!! Renoise!! Magic Ball!!
// Loop Iteration: Environment & Life Physics, Render

#define DIRECTINPUT_VERSION 0x0800
//#define STRICT			// Who knows?

#include <windows.h>	// Windows Stuff
#include <d3d9.h>
#include <d3dx9.h>
#include <d3dx9math.h>
#include <string>
#include <dinput.h>
#include <dshow.h>

using namespace std;

// Framework Class for Basic Direct3D Windows Game Application
class BD3DWGA
{


};

//////////////////////////////////////////////////////////////////////////////////////////
// Macros / Constants
//////////////////////////////////////////////////////////////////////////////////////////
#define RAND_RANGE(x,y) ( (x) + (rand()%((y)-(x)+1)))
#define PI         ((float)3.141592654f)

// Windows Constants
#define		WINDOW_WIDTH	800 //1024
#define		WINDOW_HEIGHT	600 //768

// Game Dimension Constants
#define		GAME_XBEGIN		WINDOW_WIDTH/5
#define		GAME_XEND		WINDOW_WIDTH*4/5

// Paddle Constants
#define PADDLE_YSIZE 20
#define PADDLE_YSTART WINDOW_HEIGHT-25
#define PADDLE_XSIZE	125

// Block Constants
#define BLOCK_DEAD		0
#define BLOCK_ALIVE		1
#define BLOCK_ALIVE2	2
#define BLOCK_XSIZE		32
#define BLOCK_YSIZE		32
#define NUM_XB	20	// Number of Blocks in X Direction
#define NUM_YB	20	// Number of Blocks in Y Direction
#define NUM_BLOCKS	(NUM_XB*NUM_YB)	// Total # of Blocks
#define NUM_TEX	12

// Ball Constants
#define NUM_BALL		1
#define BALL_RADIUS		8
#define INDEX_XV		0
#define INDEX_YV		1

// Frames/Sec Rate Locking Constant 0-15 = 63 frames / sec, 16 = 40 f/sec
#define COUNT			15

// Music ON (1) or OFF (0)
#define MUSIC		0

// Computer Controlled Paddle ON (1) or OFF (0)
#define COMPUTER	1

// Number of Frames for Initialization
#define NUM_INITFRAMES	400

//////////////////////////////////////////////////////////////////////////////////////////
// Function Prototypes
//////////////////////////////////////////////////////////////////////////////////////////

// Windows Functions
LRESULT WINAPI WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
void	RegisterWindowClass(HINSTANCE hInstance);
void	CreateAppWindow(HINSTANCE hInstance);

// Direct X Functions
HRESULT InitFullScreenDirect3D();
void	CleanUpDirect3D();

// Frames per Second Functions
bool Font_Setup();

// Block Function
void Construct_Blocks();

// Ball Functions
void Init_Balls();
void Build_Sin_Cos_Tables();
void Optimized_Collisions();

//////////////////////////////////////////////////////////////////////////////////////////
// Structure Definitions
//////////////////////////////////////////////////////////////////////////////////////////

// Ball Structure
typedef struct BALL_TYP
{
	int state;          // the state of the object (general)
	int color;           // attributes pertaining to the object (general)
	float varsF[2];    // stack of 2 floats
	RECT sprite;		// Sprite Extraction Rectangle
	D3DXVECTOR2	pos;	// Position Vector
	D3DXVECTOR2 scale;	// Scale Vector
} BALL, *BALL_PTR;

// Block Structures
// a 2D vertex
typedef struct VERTEX2DF_TYP
{
		float x,y; // the vertex
} VERTEX2DF, *VERTEX2DF_PTR;

// a 2D polygon
typedef struct POLYGON2D_TYP
{
        int state;        // state of polygon
        int num_verts;    // number of vertices
        int type;         // type of block (texture)
		float rotation;		// Amount in Radians to rotate bitmap.
		float varsF[2];		// 2 floats for x and y velocity		
		D3DXVECTOR2	center;	// Center for Rotation
		D3DXVECTOR2 pos;	// Block Position
		D3DXVECTOR2 scale;	// Blocks Scale
		D3DXVECTOR2 initpos;	// Block's initial position
        VERTEX2DF *vlist; // pointer to vertex list
		IDirect3DTexture9* g_pTex;
} POLYGON2D, *POLYGON2D_PTR;

//////////////////////////////////////////////////////////////////////////////////////////
// Global Variables
//////////////////////////////////////////////////////////////////////////////////////////

// Direct X Variables
IDirect3D9*			g_pDirect3D = NULL;
IDirect3DDevice9*	g_pDirect3DDevice = NULL;
ID3DXFont* Font   = 0;
IDirect3DTexture9* g_pBlockTex[NUM_TEX] = {0,0,0,0,0,0,0,0,0,0,0};

// Paddle Position Vector
D3DXVECTOR2			paddle;

// storage for our lookup tables
float cos_look[361]; // 1 extra so we can store 0-360 inclusive
float sin_look[361]; // 1 extra so we can store 0-360 inclusive

// Balls
BALL balls[NUM_BALL];

// Blocks
POLYGON2D block[NUM_BLOCKS];

// Windows Variables
HWND g_hWnd;

// 3D Card (Hardware_Vertex_Processing) Indicator Variable
int vp = 0;

// Misc. Variables
int player_score = 0;

//////////////////////////////////////////////////////////////////////////////////////////
// Game Init, ShutDown and Main Globals
//////////////////////////////////////////////////////////////////////////////////////////

// Texture Variables
IDirect3DTexture9*	g_pTexture = 0;
ID3DXSprite*		g_pSprite = 0;
IDirect3DTexture9*	g_pBackgroundTex = 0;
IDirect3DTexture9* g_pPaddleTex = 0;

// Position Vector and Scale for Paddle
D3DXVECTOR2			bscale1;
D3DXVECTOR2			scale1;

// Direct Input Variables
LPDIRECTINPUT8			m_pDI;
LPDIRECTINPUTDEVICE8	m_pMouse;

// Frame Rate Locking Variable
int start_clock_count = 0;

// String Buffer used to print text to screen
char buffer[340];
	
// Frames per Second Counting Variables
int FrameCnt=0;
float currTime=0,FPS=0,TimeElapsed=0,lastTime=0;
char FPSString[9];

// MP3 Data * Direct Show Stuff
bool			g_bBackgroundMusicActive = 0;
IGraphBuilder	*g_pGraph;
IMediaControl	*g_pMediaControl;
IMediaEvent		*g_pEvent;
IMediaSeeking	*g_pSeeking;

///////////////////////////////////////////////////////////////////////////////////////////
// Game_Main()
//////////////////////////////////////////////////////////////////////////////////////////

void Game_Main()
{
static int init_counter = 0;
	if (MUSIC)
	{
		// Check the Music
		long		evCode;
	
		// Check the event code
		g_pEvent->WaitForCompletion( 0, &evCode );
	
		// If the music is done, restart it
		if( evCode == EC_COMPLETE ) {
			// Set the starting position to 0
			LONGLONG lStartPos = 0;
			// Stop the music
			g_pMediaControl->Stop();
			// Set the positions
			g_pSeeking->SetPositions( &lStartPos, AM_SEEKING_AbsolutePositioning, NULL, AM_SEEKING_NoPositioning );
			// Run the music
			g_pMediaControl->Run();
		}
	}

	// Draw the Scene
	// Start the timing clock for frames / sec counter and frame rate locking loop
	start_clock_count = (int)(currTime  = (float)timeGetTime());

	// Update: Compute the frames per second.
	float timeDelta = (currTime - lastTime)*0.001f;
	FrameCnt++;
	TimeElapsed += timeDelta;
	if(TimeElapsed >= 1.0f)
	{
		FPS = (float)FrameCnt / TimeElapsed;
		sprintf(FPSString, "(%2.0f)", FPS);
		FPSString[8] = '\0'; // mark end of string
		TimeElapsed = 0.0f;
		FrameCnt    = 0;
	}
	lastTime = currTime;

	// Check DirectInput Mouse Device State
	DIMOUSESTATE mouse_state;
	if (SUCCEEDED(m_pMouse->GetDeviceState(sizeof(DIMOUSESTATE),&mouse_state)))
	{
		if (!COMPUTER)
			// Update Paddle Position Here
			paddle.x += mouse_state.lX;
		else if (NUM_BALL > 0)
		{
			int the_one = 0;
			paddle.x = balls[the_one].pos.x - 50;
			for (int a = 0; a < NUM_BALL; a++)
			{
				if (balls[a].state && balls[a].pos.y > balls[the_one].pos.y)
				{
					paddle.x = balls[a].pos.x - 50;
					the_one = a;
				}
			}
		}
		else
			paddle.x = balls[0].pos.x - 50;

		// Keep Paddle within Screen Bounds
		if (paddle.x > GAME_XEND - PADDLE_XSIZE)
			paddle.x = GAME_XEND - PADDLE_XSIZE;
		if (paddle.x < GAME_XBEGIN)
			paddle.x = GAME_XBEGIN;
	}

	// Clear Direct3D Device to RGB Blue
	g_pDirect3DDevice->Clear(0,0,D3DCLEAR_TARGET,
		D3DCOLOR_XRGB(0,0,0),0,0);

	// Begin Rendering
	g_pDirect3DDevice->BeginScene();

	// Begin Sprite Rendering
	g_pSprite->Begin();

	// Draw Background
	g_pSprite->Draw(g_pBackgroundTex, NULL, &bscale1, NULL, 0, NULL, 0xFFFFFFFF);
	
	// Draw Paddle on Screen
	g_pSprite->Draw(g_pPaddleTex, NULL, &scale1, NULL, 0, &paddle, 0xFFFFFFFF);

	if (init_counter > NUM_INITFRAMES)
	{

	// Draw Blocks on Screen
	for (int a=0; a < NUM_BLOCKS; a++)
	{
		if (block[a].state)
			g_pSprite->Draw(block[a].g_pTex, NULL, &block[a].scale, &block[a].center, block[a].rotation, &block[a].pos, 0xFFFFFFFF);
	}

	// Move, then Draw Balls on Screen, if ALIVE
	for (a = 0; a < NUM_BALL; a++)
	{
		if (balls[a].state)
		{
			// check if sprite is within screen bounds
			if (balls[a].pos.x < GAME_XBEGIN || balls[a].pos.x > GAME_XEND - 20 * balls[a].scale.x)
			{
				// Update position with velocity			// time-based velocity
				balls[a].pos.x -= balls[a].varsF[INDEX_XV];	// * dt;
				balls[a].varsF[INDEX_XV] = -balls[a].varsF[INDEX_XV];
			}
			if (balls[a].pos.y < 0)
			{
				// Updated position with velocity			// time-based velocity
				balls[a].pos.y -= balls[a].varsF[INDEX_YV];	// * dt;
				balls[a].varsF[INDEX_YV] = -balls[a].varsF[INDEX_YV];
			}
			// if sprite goes past paddle, ball state is zero...dead
			if (balls[a].pos.y > WINDOW_HEIGHT - PADDLE_YSIZE)
				balls[a].state = 0;
			g_pSprite->Draw(g_pTexture, NULL, &balls[a].scale,NULL,0, &balls[a].pos ,0xFFFFFFFF);
		} // end if balls[a].state
	} // end for a: 0 to NUM_BALL

	// Close Sprite Rendering
	g_pSprite->End();

	// Compute Optimized Collisions (also Move Balls)
	Optimized_Collisions();

	// end if init_counter > NUM_INITFRAMES 
	} else {

	// Before Game Play, Draw, Move, Rotate Blocks.
	for (int a=0; a < NUM_BLOCKS; a++)
	{

		// Rotate Block and POSITION of Block
		block[a].rotation += 0.02f;
		if (block[a].rotation > PI*2)
			block[a].rotation = 0.0f;

		// Move Block
		block[a].initpos.x += block[a].varsF[INDEX_XV];
		block[a].initpos.y += block[a].varsF[INDEX_YV];

		// IF Block is Alive, Draw the Block
		if (block[a].state)
			g_pSprite->Draw(block[a].g_pTex, NULL, &block[a].scale, &block[a].center, block[a].rotation, &block[a].initpos, 0xFFFFFFFF);

		if (init_counter == NUM_INITFRAMES)
		{
			for (int a = 0; a < NUM_BLOCKS; a++)
				block[a].rotation = 0.0f;
		}
	}

	// Close Sprite Rendering
	g_pSprite->End();

	// ADD one to frame counter for initialization fun
	init_counter++;

	} // end else if init_counter < NUM_INITFRAMES

	// Render On-Screen Score IF there's a 3D Card available
	if (vp == D3DCREATE_HARDWARE_VERTEXPROCESSING)
	{
		RECT rect = {0, 275, GAME_XBEGIN, WINDOW_HEIGHT};
		sprintf(buffer,"Score:\n%2d\n",player_score);
		Font->DrawText(buffer,-1,&rect,DT_TOP | DT_LEFT | DT_CENTER, 0xffffffff);
	}

	// End Rendering
	g_pDirect3DDevice->EndScene();

	// Copy Back Buffer to Primary Buffer (Display Scene)
	g_pDirect3DDevice->Present(NULL,NULL,NULL,NULL);

	// End of Render Function, count = amount of time to wait...???
	while((timeGetTime() - start_clock_count) < COUNT);
} // end Game_Main()

///////////////////////////////////////////////////////////////////////////////////////////
// Game_Shutdown()
//////////////////////////////////////////////////////////////////////////////////////////

void Game_Shutdown()
{
	// Release Sprite Interface
	g_pSprite->Release();

	// Release Blocks Texture
	for (int a=0; a<NUM_TEX; a++)
		g_pBlockTex[a]->Release();

	// Release Paddle Texture
	g_pPaddleTex->Release();

	// Release Background Texture
	g_pBackgroundTex->Release();

	// Release Balls Texture
	g_pTexture->Release();

	// Release Font
	Font->Release();

	// Shutdown Direct Input Properly
    if (m_pDI) 
    { 
        if (m_pMouse)
        { 
        // Always unacquire device before calling Release(). 
            m_pMouse->Unacquire(); 
            m_pMouse->Release();
            m_pMouse = NULL; 
        } 
		// Release Direct Input Object...didn't we just release the device? YEP that too!!!
        m_pDI->Release();
        m_pDI = NULL; 
    } 

	if (MUSIC)
	{
		// Direct Show Shutdown & Clean Up
		// Stop the song if playing
		g_pMediaControl->Stop();

		// Clean up
		g_pSeeking->Release();
		g_pMediaControl->Release();
		g_pEvent->Release();
		g_pGraph->Release();
	}

	// Call to ShutDown Direct3D
	CleanUpDirect3D();
} // end Game_Shutdown

///////////////////////////////////////////////////////////////////////////////////////////
// Game_Init()
//////////////////////////////////////////////////////////////////////////////////////////

HRESULT Game_Init()
{
	// Seed Random Number Generator
	srand(timeGetTime());

	// Initialize Direct Input
	HRESULT hr;

	if (MUSIC)
	{
		// Direct Show Start Initialization
		// Initialize COM
		CoInitialize( NULL );

		// Create the graph
		CoCreateInstance(	CLSID_FilterGraph, 
						NULL, 
						CLSCTX_INPROC_SERVER, 
						IID_IGraphBuilder, 
						(void **)&g_pGraph );

		// Query for interface objects
		g_pGraph->QueryInterface( IID_IMediaControl, (void **)&g_pMediaControl );
		g_pGraph->QueryInterface( IID_IMediaEvent, (void **)&g_pEvent );
		g_pGraph->QueryInterface( IID_IMediaSeeking, (void **)&g_pSeeking );

		// Load the song (insert your own file name below)
		hr = g_pGraph->RenderFile(L"c:\\Hyperlink.MP3", NULL);
		if( hr != S_OK ) {
			return( 0 );
		}
		// Set the playback rate
		g_pSeeking->SetRate( 1.00 );
		// Play the song
		g_pMediaControl->Run();
		// Set background music active flag
		g_bBackgroundMusicActive = 1;

		// End Direct Show Initialization	
	}

    // Create the base DirectInput object
    hr = DirectInput8Create( GetModuleHandle(NULL), DIRECTINPUT_VERSION, 
                              IID_IDirectInput8, (VOID**)&m_pDI, NULL );

	// Create the Mouse Direct Input Device
	hr = m_pDI->CreateDevice(GUID_SysMouse, &m_pMouse, NULL);

	// Set the Mouse Data Format
	hr = m_pMouse->SetDataFormat(&c_dfDIMouse);

	// Set the Mouse Cooperative Level (Behavior)
	hr = m_pMouse->SetCooperativeLevel( g_hWnd,DISCL_EXCLUSIVE | DISCL_FOREGROUND);

	// First, create an event and associate it with the mouse device.
	// You are instructing Microsoft DirectInput to notify the mouse device object 
	// whenever a hardware interrupt indicates that new data is available.
	HANDLE g_hMouseEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	hr = m_pMouse->SetEventNotification(g_hMouseEvent);

	// Now set the buffer size so that DirectInput can store any input data until you 
	// are ready to view it. To set the buffer size, initialize a DIPROPDWORD structure 
	// with information about itself and about the property you want to set. The key value 
	// is the last one, dwData, which is initialized with the number of items 
	// you want the buffer to hold.

	DIPROPDWORD dipdw;
    // the header
    dipdw.diph.dwSize       = sizeof(DIPROPDWORD);
    dipdw.diph.dwHeaderSize = sizeof(DIPROPHEADER);
    dipdw.diph.dwObj        = 0;
    dipdw.diph.dwHow        = DIPH_DEVICE;
    // the data
    dipdw.dwData            = 16;

	hr = m_pMouse->SetProperty(DIPROP_BUFFERSIZE, &dipdw.diph);

	// Acquire the mouse before we can get data from it.
	m_pMouse->Acquire();

	// Initialize Frames per Second Counter
	lastTime = (float)timeGetTime();

	// Build Sin Cos lookup tables
	Build_Sin_Cos_Tables();

	// Initialize Balls (Translation, Scaling, Sprite Selection)
	Init_Balls();

	// Initialize Direct3D
	HRESULT hResult = InitFullScreenDirect3D();

	// Call Font Initialization
	Font_Setup();

	// Create Balls Texture based on file (D3DX Helper)
	D3DXCreateTextureFromFile( g_pDirect3DDevice, "images/Purple_Ball.bmp", &g_pTexture);

	// Create Block Textures (D3DX Helper)
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/red.bmp", &g_pBlockTex[0]);
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/Orange.bmp", &g_pBlockTex[1]);
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/Yellow.bmp", &g_pBlockTex[2]);
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/Green.bmp", &g_pBlockTex[3]);
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/Blue.bmp", &g_pBlockTex[4]);
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/Purple.bmp", &g_pBlockTex[5]);
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/Yellow2.bmp", &g_pBlockTex[6]);
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/Green2.bmp", &g_pBlockTex[7]);
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/Blue2.bmp", &g_pBlockTex[8]);
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/Purple2.bmp", &g_pBlockTex[9]);
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/brown.bmp", &g_pBlockTex[10]);
	D3DXCreateTextureFromFile (g_pDirect3DDevice, "images/red2.bmp", &g_pBlockTex[11]);

	// Create Background Texture (D3DX Helper)
	D3DXCreateTextureFromFile( g_pDirect3DDevice, "images/background.bmp", &g_pBackgroundTex);

	// Create Paddle Texture (D3DX Helper)
	D3DXCreateTextureFromFile( g_pDirect3DDevice, "images/paddle_small.bmp", &g_pPaddleTex);

	// Create Sprite Interface for 2D texture drawing (D3DX Helper)
	D3DXCreateSprite(g_pDirect3DDevice, &g_pSprite);

	// Initialize Paddle Y Position
	paddle.y = PADDLE_YSTART;

	// Set Background scale according to WINDOW Dimensions
	bscale1.x = (float)WINDOW_WIDTH / 1024.0f;
	bscale1.y = (float)WINDOW_HEIGHT * 0.75f / 768.0f;

	// Set Scale for Paddle
	scale1.x = 1.0f;
	scale1.y = 0.8f;

	// Initialize Blocks
	Construct_Blocks();
	return hResult;
} // end Game_Init

///////////////////////////////////////////////////////////////////////////////////////////
// WinMain()
//////////////////////////////////////////////////////////////////////////////////////////

INT WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR, INT)
{
	// Initialize and Start the Windows Environment
	RegisterWindowClass(hInstance);
	CreateAppWindow(hInstance);
	ShowWindow(g_hWnd, SW_SHOWDEFAULT);
	UpdateWindow(g_hWnd);

	// Initialize the Game Variables
	HRESULT hResult = Game_Init();

	// Call to Windows Event Loop
	if (SUCCEEDED(hResult))
	{
		// Windows Message Variable
		MSG msg;

		// Windows Event Loop
		while(1)
		{
			if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
				if (msg.message == WM_QUIT)
					break;
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			} else {

				Game_Main();
			}
		} // end while
		WPARAM result = msg.wParam;
	} // end if SUCCEEDED...

	// Clean up, shut down, etc.
	Game_Shutdown();
	return 0;
} // end WinMain()

//////////////////////////////////////////////////////////////////////////////////////////
// Optimized_Collisions()
//////////////////////////////////////////////////////////////////////////////////////////

void Optimized_Collisions()
{
// Optimization Variables
RECT minmax;
static RECT minmax2 = {0,0,0,1000};

// Math Variables, thanks to Andre LaMothe for these (but I know what's going on too...)
float length,s,t,s1x,s1y,s2x,s2y,p0x,p0y,p1x,p1y,p2x,p2y,p3x,p3y,xi,yi,npx,npy,Nx,Ny,Fx,Fy;

// Initialize MINMAX RECT here
minmax.left = 2000;
minmax.top = 2000;
minmax.right = 0;
minmax.bottom = 0;
int poly_count = 0;

// Create Minmax RECT here and this works we love it!!! <SMILE>

	for (int a = 0; a < NUM_XB; a++)
	{
		for (int b = 0; b < NUM_YB; b++)
		{
			if (block[poly_count].state)
			{
				for (int index = 0; index < block[poly_count].num_verts; index++)
				{
					if (block[poly_count].vlist[index].x + block[poly_count].pos.x < minmax.left)
						minmax.left = (long)(block[poly_count].vlist[index].x + block[poly_count].pos.x);
					if (block[poly_count].vlist[index].x + block[poly_count].pos.x > minmax.right)
						minmax.right = (long)(block[poly_count].vlist[index].x+ block[poly_count].pos.x);
					if (block[poly_count].vlist[index].y + block[poly_count].pos.y < minmax.top)
						minmax.top = (long)(block[poly_count].vlist[index].y + block[poly_count].pos.y);
					if (block[poly_count].vlist[index].y + block[poly_count].pos.y > minmax.bottom)
						minmax.bottom = (long)(block[poly_count].vlist[index].y + block[poly_count].pos.y);
				} // end for
			} // end if

			// go to next 'shape' triangle
			poly_count++;

		} // end for
	} // end for

	for (int change = 0; change < NUM_BALL; change++)
	{
		if (balls[change].state)
		{
			if (balls[change].pos.y - BALL_RADIUS < minmax2.bottom)
				minmax2.bottom = (long)(balls[change].pos.y - BALL_RADIUS);
		}
	}

	// set blocks state
	for (change = 0; change < poly_count; change++)
	{
		if (block[change].state &&
			block[change].vlist[0].y + block[change].pos.y < minmax2.bottom && 
			block[change].vlist[1].y + block[change].pos.y < minmax2.bottom &&
			block[change].vlist[2].y + block[change].pos.y < minmax2.bottom)
			// gentlemen, start your engines!
			block[change].state = BLOCK_ALIVE2;
		else if (block[change].state)
		{
			block[change].state = BLOCK_ALIVE;
		}
	}

// this function computes if any ball has hit one of the edges of the polygons
// if so the ball is bounced
	
for (int index = 0; index < NUM_BALL; index++)
    {
	// IF ball is ALIVE!
	if (balls[index].state)
	{

	// Move the Balls								   // Time-Based Velocity
	balls[index].pos.x += balls[index].varsF[INDEX_XV];// * dt;
	balls[index].pos.y += balls[index].varsF[INDEX_YV];// * dt;

	// Paddle Collision
	if (balls[index].pos.y > PADDLE_YSTART && balls[index].pos.x > paddle.x && balls[index].pos.x < paddle.x + PADDLE_XSIZE)
	{
		balls[index].varsF[INDEX_YV] *= -1;
		balls[index].pos.y += balls[index].varsF[INDEX_YV];
	}

	// IF ball is within bounding rectangle of all blocks...
	if (balls[index].pos.x - BALL_RADIUS < minmax.right && 
		balls[index].pos.x + BALL_RADIUS > minmax.left &&
		balls[index].pos.y - BALL_RADIUS < minmax.bottom &&
		balls[index].pos.y + BALL_RADIUS > minmax.top)
	{

	for (int a = 0; a < NUM_BLOCKS; a++)
	{
	// IF block is ALIVE, but not ALIVE2
	if (block[a].state == BLOCK_ALIVE)
	{

    // now project velocity vector forward and test for intersection with all lines of polygon shape

    // build up vector in direction of trajectory
    p0x=balls[index].pos.x;
    p0y=balls[index].pos.y;

// this is the velocity vector used as segment 1
    p1x=balls[index].pos.x+balls[index].varsF[INDEX_XV];
    p1y=balls[index].pos.y+balls[index].varsF[INDEX_YV];
    s1x=p1x-p0x;
    s1y=p1y-p0y;

    // normalize and scale
    length = (float)(sqrt(s1x*s1x+s1y*s1y));
    s1x = (float)(BALL_RADIUS*s1x/length);
    s1y = (float)(BALL_RADIUS*s1y/length); 
    p1x = p0x + s1x;
    p1y = p0y + s1y;

    // for each line try and intersect
    for (int line=0; line < block[a].num_verts; line++)
    {
    // now build up vector based on line
    p2x=block[a].vlist[line].x+block[a].pos.x;
    p2y=block[a].vlist[line].y+block[a].pos.y;

    p3x=block[a].vlist[(line+1)%(block[a].num_verts)].x+block[a].pos.x;
    p3y=block[a].vlist[(line+1)%(block[a].num_verts)].y+block[a].pos.y;

    s2x=p3x-p2x;
    s2y=p3y-p2y;

    // compute s and t, the parameters
    s = (-s1y*(p0x-p2x) + s1x*(p0y-p2y))/(-s2x*s1y + s1x*s2y);
    t =  (s2x*(p0y-p2y) - s2y*(p0x-p2x))/(-s2x*s1y + s1x*s2y);

    // test for valid range (0..1)
    if (s >= 0 && s <=1 && t >= 0 && t <=1)
       {
       // find collision point based on s
       xi = p0x+s*s1x;
       yi = p0y+s*s1y;

       // now we know point of intersection, reflect ball at current location

       // N = (-I . N')*N'
       // F = 2*N + I
       npx = -s2y;
       npy = s2x;

       // normalize p
       length = (float)(sqrt(npx*npx+npy*npy));
       npx/=length;
       npy/=length;

       // compute N = (-I . N')*N'
       Nx = -(balls[index].varsF[INDEX_XV]*npx + balls[index].varsF[INDEX_YV]*npy)*npx;
       Ny = -(balls[index].varsF[INDEX_XV]*npx + balls[index].varsF[INDEX_YV]*npy)*npy;

       // compute F = 2*N + I
       Fx = 2*Nx + balls[index].varsF[INDEX_XV];
       Fy = 2*Ny + balls[index].varsF[INDEX_YV];

       // update velocity with results
       balls[index].varsF[INDEX_XV] = Fx;
       balls[index].varsF[INDEX_YV] = Fy;

	   // Update position								// time-based velocity
       balls[index].pos.x+=balls[index].varsF[INDEX_XV];// * dt;
       balls[index].pos.y+=balls[index].varsF[INDEX_YV];// * dt;

	   // eliminate block
	   block[a].state = BLOCK_DEAD;

	   // update SCORE
	   player_score+=10;

       } // end if

	} // end for line

	} // end if block is alive

	} // end loop for each shape a

	} // end IF ball is within bounding box.

	} // end IF ball is ALIVE

    } // end for ball index
} // end Optimized_Collisions()

//////////////////////////////////////////////////////////////////////////////////////////
// Init_Balls()
//////////////////////////////////////////////////////////////////////////////////////////

void Init_Balls()
{
	// Set Initial conditions for all the balls
	for (int index = 0; index < NUM_BALL; index++)
	{
		// Set Balls ALIVE to start
		balls[index].state = 1;
			
		// Set Position
		balls[index].pos.x = (float)RAND_RANGE( GAME_XBEGIN, GAME_XEND);
		balls[index].pos.y = (float)RAND_RANGE( 450, WINDOW_HEIGHT - PADDLE_YSIZE);
		
		// Set Scale
		balls[index].scale.x = balls[index].scale.y = (float)(BALL_RADIUS / 16.0f);

		do
		{
			// Choose 0 to 359 angle for velocity
			int ang = rand()%360;

			// Set Velocity
			balls[index].varsF[INDEX_XV] = cos_look[ang] * 3; //RAND_RANGE(3,8);
			balls[index].varsF[INDEX_YV] = sin_look[ang] * 3; //RAND_RANGE(3,8);

		} while (abs((int)balls[index].varsF[INDEX_XV]) < 1 || abs((int)balls[index].varsF[INDEX_YV]) < 1);
	} // end for
} // end Init_Balls

//////////////////////////////////////////////////////////////////////////////////////////
// Construct_Blocks()
//////////////////////////////////////////////////////////////////////////////////////////

void Construct_Blocks()
{
int poly_count = 0;		// Number of Blocks Constructed

VERTEX2DF base_block[4] = // Block Vertices Prototype
{
	0,0,
	BLOCK_XSIZE,0,
	BLOCK_XSIZE,BLOCK_YSIZE,
	0,BLOCK_YSIZE
};

for (int a = 0; a < NUM_XB; a++)
{
	for (int b = 0; b < NUM_YB; b++)
	{
		// Create each block.
		block[poly_count].num_verts			= 4;

		// Block Texture Scale for D3DX Helper
		block[poly_count].scale.x			= (float)(GAME_XEND - GAME_XBEGIN) / (float)(NUM_XB * BLOCK_XSIZE);
		block[poly_count].scale.y			= (float)(WINDOW_HEIGHT - 150) / (float)(NUM_YB * BLOCK_YSIZE);

		// This may need to change based on scaled drawings of blocks
		block[poly_count].pos.x = GAME_XBEGIN + (a * BLOCK_XSIZE * block[poly_count].scale.x);
		block[poly_count].pos.y = b * BLOCK_YSIZE * block[poly_count].scale.y;

//		block[poly_count].center.x = (GAME_XBEGIN + GAME_XEND) * 0.5f * block[poly_count].scale.x;
//		block[poly_count].center.y = 225 * block[poly_count].scale.y;

		block[poly_count].center.x = 16 * block[poly_count].scale.x;
		block[poly_count].center.y = 16 * block[poly_count].scale.y;

		block[poly_count].rotation = 0.002f;

		switch(rand()%4) {
		case 0:
			block[poly_count].initpos.x = (float)(rand()%(WINDOW_WIDTH - BLOCK_XSIZE));
			block[poly_count].initpos.y = 0;
			break;
		case 1:
			block[poly_count].initpos.x = 0;
			block[poly_count].initpos.y = (float)(rand()%(WINDOW_HEIGHT - BLOCK_YSIZE));
			break;
		case 2:
			block[poly_count].initpos.x = (float)(rand()%(WINDOW_WIDTH - BLOCK_XSIZE));
			block[poly_count].initpos.y = WINDOW_HEIGHT - BLOCK_YSIZE;
			break;
		case 3:
			block[poly_count].initpos.x = (WINDOW_WIDTH - BLOCK_XSIZE);
			block[poly_count].initpos.y = (float)(rand()%(WINDOW_HEIGHT - BLOCK_YSIZE));
			break;
		};

		// Set Velocity Based on Difference between InitPos and Pos
		block[poly_count].varsF[INDEX_XV] = (block[poly_count].initpos.x - block[poly_count].pos.x) / (float)NUM_INITFRAMES;
		block[poly_count].varsF[INDEX_YV] = (block[poly_count].initpos.y - block[poly_count].pos.y) / (float)NUM_INITFRAMES;

		block[poly_count].varsF[INDEX_XV] = -block[poly_count].varsF[INDEX_XV];
		block[poly_count].varsF[INDEX_YV] = -block[poly_count].varsF[INDEX_YV];

		// Block Texture is 0 to NUM_TEX - 1
			block[poly_count].g_pTex = g_pBlockTex[((a+b)/2)%NUM_TEX]; // kind of cool
//			block[poly_count].g_pTex = g_pBlockTex[(a+b)%NUM_TEX];

		
		// Note: If using more than 4 vertices this will need to change
		block[poly_count].vlist				= new VERTEX2DF [4];

		// Copy Block Vertices Prototype into actual Block
		for (int index = 0; index < 4; index++)
		{
			// SCALE changes affect this too.
			block[poly_count].vlist[index].x = base_block[index].x * block[poly_count].scale.x;
			block[poly_count].vlist[index].y = base_block[index].y * block[poly_count].scale.y;
		}
		// Pattern for DEMO LEVEL
		if (block[poly_count].pos.x < (GAME_XBEGIN + 50) || block[poly_count].pos.x > (GAME_XEND - 50) 
			|| block[poly_count].pos.y < 30 || block[poly_count].pos.y > 410)
			block[poly_count].state = BLOCK_DEAD;
		else 
			block[poly_count].state				= BLOCK_ALIVE;
		
		// Don't leave this out...big mistake...1 1/2 hours...
		poly_count++;
	}
}
} // end Construct_Blocks()

//////////////////////////////////////////////////////////////////////////////////////////
// WndProc()
//////////////////////////////////////////////////////////////////////////////////////////

LRESULT WINAPI WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE:
		return 0;

	case WM_DESTROY:
		PostQuitMessage( 0 );
		return 0;

	case WM_PAINT:
		ValidateRect(g_hWnd, NULL);
		return 0;

	case WM_KEYDOWN:
		switch(wParam)
		{
		case VK_ESCAPE:
			PostQuitMessage(WM_QUIT);
			break;
		}
	}
	return DefWindowProc(hWnd, msg, wParam, lParam);
} // end WndProc

//////////////////////////////////////////////////////////////////////////////////////////
// Build_Sin_Cos_Tables()
//////////////////////////////////////////////////////////////////////////////////////////

void Build_Sin_Cos_Tables()
{
// create sin/cos lookup table
// generate the tables 0 - 360 inclusive
for (int ang = 0; ang <= 360; ang++)
    {
    // convert ang to radians
    float theta = (float)ang*PI/(float)180;

    // insert next entry into table
    cos_look[ang] = (float)cos(theta);
    sin_look[ang] = (float)sin(theta);

    } // end for ang

} // end Build_Sin_Cos_Tables

//////////////////////////////////////////////////////////////////////////////////////////
// RegisterWindowClass()
//////////////////////////////////////////////////////////////////////////////////////////

void RegisterWindowClass(HINSTANCE hInstance)
{
	// Variable for Window Class
	WNDCLASSEX	wc;

	// Defining Window Class
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc		= WndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= hInstance;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= (HCURSOR)LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName		= NULL;
	wc.lpszClassName	= "WinApp";
	wc.hIconSm			= NULL;

	// Function Call to Register Window Class EX!
	RegisterClassEx(&wc);
}	

//////////////////////////////////////////////////////////////////////////////////////////
// CreateAppWindow()
//////////////////////////////////////////////////////////////////////////////////////////

void CreateAppWindow(HINSTANCE hInstance)
{
	g_hWnd = CreateWindowEx(
		NULL,
		"WinApp",						// Windows Class Name
		"DirectX9.0 Windows Application",	// Title Bar Text
		WS_OVERLAPPEDWINDOW,			// Window's Style
		0,								// Window's Horizontal Position
		0,								// Window's Vertical Position
		WINDOW_WIDTH,					// Window's Width
		WINDOW_HEIGHT,					// Window's Height
		GetDesktopWindow(),				// Parent Window's Handle
		NULL,							// Window's Menu Handle
		hInstance,						// Instance Handle
		NULL);
}

//////////////////////////////////////////////////////////////////////////////////////////
// InitFullScreenDirect3D()
//////////////////////////////////////////////////////////////////////////////////////////

HRESULT InitFullScreenDirect3D()
{
	// Create the IDirect3D9 Object

	g_pDirect3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (g_pDirect3D == NULL)
	{
		MessageBox(g_hWnd, 
			"Sorry. This program won't\nrun on your system.",
			"DirectX Object Creation Error", MB_OK);
		return E_FAIL;
	}

	// Check for Hardware Vertex Processing

	D3DCAPS9 caps;
	g_pDirect3D->GetDeviceCaps(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, &caps);
	if ( caps.DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT )
		vp = D3DCREATE_HARDWARE_VERTEXPROCESSING;
	else
		vp = D3DCREATE_SOFTWARE_VERTEXPROCESSING;

	// Fill out the D3DPRESENT_PARAMETERS structure

	D3DPRESENT_PARAMETERS D3DPresentParams;
	ZeroMemory(&D3DPresentParams, sizeof(D3DPRESENT_PARAMETERS));
	D3DPresentParams.MultiSampleType	= D3DMULTISAMPLE_NONE;
	D3DPresentParams.MultiSampleQuality = 0;
	D3DPresentParams.EnableAutoDepthStencil = 1;
	D3DPresentParams.Flags = 0;
	D3DPresentParams.FullScreen_RefreshRateInHz = D3DPRESENT_RATE_DEFAULT;
	D3DPresentParams.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	D3DPresentParams.Windowed = FALSE;
	D3DPresentParams.BackBufferCount = 1;
	D3DPresentParams.BackBufferWidth = WINDOW_WIDTH;
	D3DPresentParams.BackBufferHeight = WINDOW_HEIGHT;
	D3DPresentParams.BackBufferFormat = D3DFMT_A8R8G8B8;
	D3DPresentParams.SwapEffect = D3DSWAPEFFECT_DISCARD;
	D3DPresentParams.hDeviceWindow = g_hWnd;

	// Create the Device
	
	HRESULT hResult = g_pDirect3D->CreateDevice(D3DADAPTER_DEFAULT,
		D3DDEVTYPE_HAL, g_hWnd, vp,	&D3DPresentParams, &g_pDirect3DDevice);

	if (FAILED(hResult))
	{

		// Try Again using a 16-bit depth buffer.
		D3DPresentParams.AutoDepthStencilFormat = D3DFMT_D16;

		hResult = g_pDirect3D->CreateDevice(D3DADAPTER_DEFAULT,
		D3DDEVTYPE_HAL, g_hWnd, vp,	&D3DPresentParams, &g_pDirect3DDevice);

		if ( FAILED(hResult) )
		{
			
			MessageBox(g_hWnd, 
				"Sorry. This program won't\nrun on your system.",
				"DirectX Device Creation Error", MB_OK);
			return E_FAIL;
		}
	}

	return D3D_OK;
}

//////////////////////////////////////////////////////////////////////////////////////////
// CleanUpDirect3D()
//////////////////////////////////////////////////////////////////////////////////////////

void CleanUpDirect3D()
{

	// Release Direct3D Device

	if (g_pDirect3DDevice)
		g_pDirect3DDevice->Release();

	// Release Direct3D Object Interface

	if (g_pDirect3D)
		g_pDirect3D->Release();
}

//////////////////////////////////////////////////////////////////////////////////////////
// Font Setup Function
//////////////////////////////////////////////////////////////////////////////////////////

bool Font_Setup()
{
	//
	// Initialize a LOGFONT structure that describes the font
	// we want to create.
	//

	LOGFONT lf;
	ZeroMemory(&lf, sizeof(LOGFONT));

	lf.lfHeight         = 25;    // in logical units
	lf.lfWidth          = 12;    // in logical units
	lf.lfEscapement     = 0;        
	lf.lfOrientation    = 0;     
	lf.lfWeight         = 500;   // boldness, range 0(light) - 1000(bold)
	lf.lfItalic         = false;   
	lf.lfUnderline      = false;    
	lf.lfStrikeOut      = false;    
	lf.lfCharSet        = DEFAULT_CHARSET;
	lf.lfOutPrecision   = 0;              
	lf.lfClipPrecision  = 0;          
	lf.lfQuality        = 0;           
	lf.lfPitchAndFamily = 0;           
	strcpy(lf.lfFaceName, "Times New Roman"); // font style

	//
	// Create an ID3DXFont based on 'lf'.
	//

	if(FAILED(D3DXCreateFontIndirect(g_pDirect3DDevice, &lf, &Font)))
	{
		::MessageBox(0, "D3DXCreateFontIndirect() - FAILED", 0, 0);
		::PostQuitMessage(0);
	}

	return true;
}

